criterion-0.5.0.10: Robust, reliable performance measurement and analysis

Portability | GHC
Stability | experimental
Maintainer | bos@serpentine.com

Criterion.Analysis

Description

Analysis code for benchmarks.

Synopsis

- data Outliers = Outliers {
  - samplesSeen :: !Int64
  - lowSevere :: !Int64
  - lowMild :: !Int64
  - highMild :: !Int64
  - highSevere :: !Int64
  }
- data OutlierVariance
  - = Unaffected
  - | Slight
  - | Moderate
  - | Severe
- analyseMean :: Sample -> Int -> Criterion Double
- countOutliers :: Outliers -> Int64
- classifyOutliers :: Sample -> Outliers
- noteOutliers :: Outliers -> Criterion ()
- outlierVariance :: Estimate -> Estimate -> Double -> (OutlierVariance, Double)

# Documentation

data Outliers

Outliers from sample data, calculated using the boxplot technique.

Constructors

Outliers |

Fields

samplesSeen :: !Int64
lowSevere :: !Int64

  More than 3 times the IQR below the first quartile.

lowMild :: !Int64

  Between 1.5 and 3 times the IQR below the first quartile.

highMild :: !Int64

  Between 1.5 and 3 times the IQR above the third quartile.

highSevere :: !Int64

  More than 3 times the IQR above the third quartile.

Instances

Eq Outliers |
Read Outliers |
Show Outliers |
Monoid Outliers |

data OutlierVariance

A description of the extent to which outliers in the sample data affect the sample mean and standard deviation.

Constructors

Unaffected | Less than 1% effect.
Slight | Between 1% and 10%.
Moderate | Between 10% and 50%.
Severe | Above 50% (i.e. measurements are useless).

Instances

Eq OutlierVariance |
Ord OutlierVariance |
Show OutlierVariance |

analyseMean

Arguments

:: Sample |
-> Int | Number of iterations used to compute the sample.
-> Criterion Double |

Display the mean of a `Sample`, and characterise the outliers present in the sample.

countOutliers :: Outliers -> Int64

Count the total number of outliers in a sample.

classifyOutliers :: Sample -> Outliers

Classify outliers in a data set, using the boxplot technique.

noteOutliers :: Outliers -> Criterion ()

Display a report of the `Outliers` present in a `Sample`.

outlierVariance

Arguments

:: Estimate | Bootstrap estimate of sample mean.
-> Estimate | Bootstrap estimate of sample standard deviation.
-> Double | Number of original iterations.
-> (OutlierVariance, Double) |

Compute the extent to which outliers in the sample data affect the sample mean and standard deviation.